=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg[.\d]*//" \
http://sf.net/luabind/luabind-([.0-9]+)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip) debian debian/repack.sh
