## luabind 0.9.1+git20150823+dfsg

=== debian/changelog ===
luabind (0.9.1+git20150823+dfsg-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113253)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 12:40:02 +0200

luabind (0.9.1+git20150823+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload
  * Downgrade to lua 5.1 (Closes: #1050540)
  * d/watch: Scan GitHub tags

 -- Bastian Germann <bage@debian.org>  Fri, 25 Aug 2023 22:10:22 +0000
