=== debian/watch ===
version=4
https://github.com/ValyriaTear/luabind/tags .*/tags/([\d\.]+)\.tar\.gz
